#!/usr/bin/perl -T

eval 'exec /usr/bin/perl -T -S $0 ${1+"$@"}'
    if 0; # not running under some shell

use strict;
use warnings;

my $n;
BEGIN { $n = 1000; }

use Test::More tests => $n;

use Scope::Upper qw<reap UP>;

my $count;

sub setup {
 for my $i (reverse 1 .. $n) {
  reap {
   is $count, $i, "$i-th destructor called at the right time";
   ++$count;
  } UP UP;
 }
}

$count = $n + 1;

{
 setup;
 $count = 1;
}
